&& CD_Writer
&& (c) Gregory Adam 2007
*================================================================================
&& #Include	..\Base\Include\Base.h

#ifndef TRUE
	#include	"FoxPro.h"
	#define		TRUE	.t.
	#define		FALSE	.f.
	#define		VFP_9	(Version(5) >= 900)
#endif
*================================================================================
#define VBSCRIPTFILE	'\tmp\cd.vbs'
*================================================================================
#define CD_WRITER_CLASS_VFP		'cd_writer'
&& Vista or XP SP2 with http://support.microsoft.com/kb/KB932716

&& sources http://www.microsoft.com/technet/scriptcenter/topics/imapi/imapi2-2.mspx

*================================================================================
#if FALSE && examples

	set proc to cd_writer additive
	
	local obj
	
	&& Erase
	do case
	case !cd_writer_Object(@m.obj)
		&& error
	case !m.obj.Media_Erase('Q:\')
		&& error
	endcase
	
	&& make CD with FileSystem
	local FileSystem
	&& FileSystem = 1 && ISO
	&& FileSystem = 3 && ISO + Joliet extensions
	&& FileSystem = 4 && UDF
	
	&& default FileSystem = Joliet
	
	do case
	case !cd_writer_Object(@m.obj)
		&& error
	
	case !m.obj.DiskPath_Burn('\tmp\Adam', 'Q:\', 'CouCou', m.FileSystem)
		&& error
	endcase
	
	&& burn image
	do case
	case !cd_writer_Object(@m.obj)
		&& error
	case !obj.Image_Burn('D:\tmp\In\Beta2ExpresssComboDVD.img', 'Q:\')
		&& error
	endcase
	
#endif
*-------------------------------------------------------------------------------
function cd_writer_Object(obj)
	
	return Object_create(@m.obj, CD_WRITER_CLASS_VFP)

endfunc
*-------------------------------------------------------------------------------
function Object_Create(obj, ClassName, p01, p02, p03, p04, p05, p06, p07, p08)

	local Success
	Success = TRUE
	
	local sError
	sError = on('Error')
	
	private Object_Create_Error
	Object_Create_Error = FALSE
	
	obj = null
	
	on error Object_Create_Error = TRUE
	
	do case
	case inlist(pcount(), 0, 1)
		assert FALSE
		Success = FALSE
	
	case inlist(pcount(), 2)
		obj = CreateObject(m.ClassName)
	
	case inlist(pcount(), 3)
		obj = CreateObject(m.ClassName, m.p01)
	
	case inlist(pcount(), 4)
		obj = CreateObject(m.ClassName, m.p01, m.p02)
	
	case inlist(pcount(), 5)
		obj = CreateObject(m.ClassName, m.p01, m.p02, m.p03)
	
	case inlist(pcount(), 6)
		obj = CreateObject(m.ClassName, m.p01, m.p02, m.p03, m.p04)
	
	case inlist(pcount(), 7)
		obj = CreateObject(m.ClassName, m.p01, m.p02, m.p03, m.p04, m.p05)
	
	case inlist(pcount(), 8)
		obj = CreateObject(m.ClassName, m.p01, m.p02, m.p03, m.p04, m.p05, m.p06)
	
	case inlist(pcount(), 9)
		obj = CreateObject(m.ClassName, m.p01, m.p02, m.p03, m.p04, m.p05, m.p06, m.p07)
	
	case inlist(pcount(), 10)
		obj = CreateObject(m.ClassName, m.p01, m.p02, m.p03, m.p04, m.p05, m.p06, m.p07, m.p08)
	
	otherwise
		assert FALSE
		Success = FALSE
	
	endcase
	on error &sError
	
	do case
	case !m.Success
	
	case m.Object_Create_Error
		assert FALSE
		Success = FALSE
	
	case !inlist(vartype(m.obj), T_OBJECT)
		assert FALSE
		Success = FALSE
	
	endcase
	
	return m.Success
endfunc
*--------------------------------------------------------------------------
function WaitWindowAtMouse(msg)

	if( !empty(m.msg) )
		wait window nowait at mRow(_screen.name), mCol(_screen.name) m.msg
	else
		wait clear
	endif
endfunc
*--------------------------------------------------------------------------
*--------------------------------------------------------------------------

*--------------------------------------------------------------------------
*==========================================================================
#ifndef	LIGHTWEIGHT_CLASS
	#define	LIGHTWEIGHT_CLASS	[_LightWeightClass_]
	
	define class LIGHTWEIGHT_CLASS as Relation

	hidden	BaseClass, ChildAlias, ChildOrder, ClassLibrary, ;
						Comment, OneToMany, ;
						Parent, ParentAlias, RelationalExpr, Tag
enddefine
*==========================================================================
#define	CD_DISCMASTER_CLASS			"IMAPI2.MsftDiscMaster2"
#define	CD_RECORDER_CLASS			"IMAPI2.MsftDiscRecorder2"
#define CD_FORMAT_ERASE_CLASS		"IMAPI2.MsftDiscFormat2Erase"
#define CD_WRITER_CLASS				"IMAPI2.MsftDiscFormat2Data"
#define	CD_FILESYSTEMIMAGE_CLASS	"IMAPI2FS.MsftFileSystemImage"

#define	FsiFileSystemNone 		0
#define	FsiFileSystemISO9660	1
#define	FsiFileSystemJoliet		2
#define	FsiFileSystemUDF		4
#define	FsiFileSystemUnknown 	0x40000000

#define FSI_FILESYSTEM_DEFAULT	bitor(FsiFileSystemISO9660, FsiFileSystemJoliet)
*==========================================================================
*==========================================================================
*==========================================================================
define	class CD_WRITER_CLASS_VFP as LIGHTWEIGHT_CLASS

*--------------------------------------------------------------------------
hidden function init()

	local Success
	Success = TRUE
	
	do case
	case !m.Success
	
	case !DoDefault()
		assert FALSE
		Success = FALSE
	
	otherwise
		declare Integer DeleteFile in win32api string @
		
	endcase
	
	return m.Success
	
endfunc
*--------------------------------------------------------------------------
hidden function DiscMaster_Object(obj)

	return Object_Create(@m.obj, CD_DISCMASTER_CLASS)

endfunc
*--------------------------------------------------------------------------
hidden function Recorder_Object(obj)

	return Object_Create(@m.obj, CD_RECORDER_CLASS)

endfunc
*--------------------------------------------------------------------------
hidden function Erase_Object(obj)

	return Object_Create(@m.obj, CD_FORMAT_ERASE_CLASS)

endfunc
*--------------------------------------------------------------------------
hidden function Writer_Object(obj)

	return Object_Create(@m.obj, CD_WRITER_CLASS)

endfunc
*--------------------------------------------------------------------------
hidden function FileSystem_Object(obj, FileSystemType)

	local Success
	Success = TRUE
	
	do case
	case !m.Success
	
	case !Object_Create(@m.obj, CD_FILESYSTEMIMAGE_CLASS)
		assert FALSE
		Success = FALSE
	
	case empty(m.FileSystemType)
		obj.FileSystemType = evl(m.FileSystemType, FSI_FILESYSTEM_DEFAULT)
	
	endcase
	
	return m.Success

endfunc
*--------------------------------------------------------------------------
hidden function Recorder_object_MountPoint(Recorder_obj, MountPoint, Index)

	local Success
	Success = TRUE
	
	local DiscMaster_Obj, mp[1], MountPoint_Found

	MountPoint_Found = FALSE
	
	do case
	case !m.Success
	
	case !inlist(vartype(m.MountPoint), T_CHARACTER)
		assert FALSE
		Success = FALSE
		
	case !m.this.DiscMaster_Object(@m.DiscMaster_Obj)
		assert FALSE
		Success = FALSE
		
	otherwise
			
		for Index = 0 to m.DiscMaster_Obj.Count - 1
			
			do case
			case !m.Success
				exit
				
			case !m.this.Recorder_Object(@m.Recorder_Obj)
				assert FALSE
				Success = FALSE
			
			otherwise
				try
					=m.Recorder_Obj.InitializeDiscRecorder(m.DiscMaster_Obj.Item[m.Index])
					mp = null
					mp = m.Recorder_Obj.VolumePathNames
					
				catch
					assert FALSE
					Success = FALSE
				
				endtry
			
			endcase
			
			do case
			case !m.Success
				exit
				
			case !empty(ascan(mp, m.MountPoint, 1,-1,1,9))
				
				MountPoint_Found = TRUE
				exit
				
			endcase
		
		endfor
	
	endcase
	
	do case
	case !m.Success
	
	case !m.MountPoint_Found
		assert FALSE
		Success = FALSE
	
	endcase
	
	return m.Success
endfunc
*--------------------------------------------------------------------------
*--------------------------------------------------------------------------
function Media_Erase(MountPoint)

	local Success
	Success = TRUE
	
	local Recorder_obj, Eraser_obj
	
	do case
	case !m.Success
	
	case !m.this.Recorder_object_MountPoint(@m.Recorder_obj, m.MountPoint)
		assert FALSE
		Success = FALSE
	
	case !m.this.Erase_Object(@m.Eraser_obj)
		assert FALSE
		Success = FALSE
	
	otherwise
		Eraser_obj.Recorder = m.Recorder_obj
		Eraser_obj.ClientName = m.this.Class
		
	endcase
	
	do case
	case !m.Success
	
	case !WaitWindowAtMouse('Erasing media')
		assert FALSE
		Success = FALSE
		
	otherwise
		try
			=m.Eraser_obj.EraseMedia()
			
		catch
			assert FALSE
			Success = FALSE
		
		endtry
	
	endcase
	
	=WaitWindowAtMouse()
	
	return m.Success
	
endfunc
*--------------------------------------------------------------------------
function DiskPath_Burn(DiskPath, MountPoint, VolumeName, FileSystemType)

	local Success
	Success = TRUE
	
	local Index, WScript_obj
	
	if( empty(m.FileSystemType) )
		FileSystemType = bitor(FsiFileSystemISO9660, FsiFileSystemJoliet)
	endif
	
	do case
	case !m.Success
	
	case !m.this.Recorder_object_MountPoint(FALSE, m.MountPoint, @m.Index)
		assert FALSE
		Success = FALSE
	
	case empty(DeleteFile(VBSCRIPTFILE)) and FALSE
		assert FALSE
		Success = FALSE
	
	otherwise
		&& Does not work in vfp: objDataWriter.Write(objFSI.CreateResultImage().ImageStream)
		local s, _False_, _True_
		_False_ = 'False'
		_True_	= 'True'
		
		text to s TextMerge noshow
			Const	FileSystem = <<FileSystemType>>
			Const	cd_id = <<Index>>
			Const	strPath = "<<DiskPath>>"
			Const	VolumeName = "<<VolumeName>>"
			
			'WScript.Console.WriteLine "Initalizing"
			Set colDiscMaster = CreateObject(CD_DISCMASTER_CLASS)
			Id = colDiscMaster.Item(Cd_id)

			set colDiscMaster = Nothing
			Set objRecorder = CreateObject(CD_RECORDER_CLASS)
			objRecorder.InitializeDiscRecorder(Id)

			Set objDataWriter = CreateObject(CD_WRITER_CLASS)
			objDataWriter.Recorder = objRecorder
			objDatawriter.ClientName = "BurnTest"
			objDatawriter.ForceMediaToBeClosed = <<_True_>>
			objDatawriter.ForceOverwrite = <<_True_>>
			

			Set objFSI = CreateObject(CD_FILESYSTEMIMAGE_CLASS)
			' objFSI.FreeMediaBlocks = objDatawriter.FreeSectorsOnMedia
			objFSI.FileSystemsToCreate = FileSystem 
			objFSI.VolumeName = VolumeName 
			objFSI.Root.AddTree strPath, <<_False_>>
			        
			'Set objResult = objFSI.CreateResultImage()
			'objStream = objFSI.CreateResultImage().ImageStream

			'WScript.StdOut.WriteLine "Writing..."
			objDataWriter.Write(objFSI.CreateResultImage().ImageStream)

			objRecorder.EjectMedia()
			
			set objDataWriter = Nothing
			set objRecorder = Nothing
			
			
			'WScript.StdOut.WriteLine "Done"

		
		endtext
	
	endcase
	
	
	do case
	case !m.Success
	
	case !Directory(JustPath(VBSCRIPTFILE))
		md (justPath(VBSCRIPTFILE))
	
	endcase
	
	do case
	case !m.Success
	
	case StrToFile(m.s, VBSCRIPTFILE) <> len(m.s)
		assert FALSE
		Success = FALSE
	
	case !Object_create(@m.WScript_obj, 'WScript.Shell')
		assert FALSE
		Success = FALSE
	
	case !WaitWindowAtMouse('Writing')
		assert FALSE
		Success = FALSE
		
	otherwise
		try 
			=m.WScript_obj.Run('"' + VBSCRIPTFILE + '"', 1, TRUE)
		
		catch 
			assert FALSE
			Success = FALSE
		
		endtry
	
	endcase
	
	=WaitWindowAtMouse()
	
	do case
	case !m.Success
	
	case empty(DeleteFile(VBSCRIPTFILE)) and FALSE
		assert FALSE
		Success = FALSE
	
	endcase
	
	return m.Success
	
endfunc
*--------------------------------------------------------------------------
function Image_Burn(ImageFileName, MountPoint)

	local Success
	Success = TRUE
	
	local Recorder_Obj, Writer_obj, Stream_Obj
	
	do case
	case !m.Success
	
	case !m.this.Recorder_object_MountPoint(@m.Recorder_Obj, m.MountPoint)
		assert FALSE
		Success = FALSE
	
	case !m.this.Writer_Object(@m.Writer_obj)
		assert FALSE
		Success = FALSE
	
	otherwise
		Writer_obj.Recorder = m.Recorder_Obj
		Writer_obj.ClientName = m.this.Class
		Writer_obj.ForceMediaToBeClosed = TRUE
		Writer_obj.ForceOverwrite = TRUE
		
	endcase
	
	do case
	case !m.Success
	
	case !Object_create(@m.Stream_Obj, 'ADODB.Stream')
		assert FALSE
		Success = FALSE
	
	otherwise
		Stream_Obj.Type = 1	&& binary
	
	endcase
	
	do case
	case !m.Success
	
	case !WaitWindowAtMouse('Reading image')
		assert FALSE
		Success = FALSE
	
	otherwise
		try
			=m.Stream_Obj.Open()
			=m.Stream_obj.LoadFromfile(m.ImageFileName)
		
		catch
			assert FALSE
			Success = FALSE
		
		endtry
	
	endcase
	
	
	do case
	case !m.Success
	
	case !WaitWindowAtMouse('Writing image')
		assert FALSE
		Success = FALSE
	
	otherwise
		try
		
			=m.Writer_obj.Write(m.Stream_Obj)
			=m.Stream_Obj.Close()
		
		catch
			assert FALSE
			Success = FALSE
		
		endtry
	
	endcase
	
	do case
	case !m.Success
	
	case !WaitWindowAtMouse('Ejecting media')
		assert FALSE
		Success = FALSE
	
	otherwise
		try
			=m.Recorder_Obj.EjectMedia()
		
		catch
			assert FALSE
			Success = FALSE
		
		endtry
	
	endcase
	
	=WaitWindowAtMouse()
	
	return m.Success
	
endfunc
*--------------------------------------------------------------------------
enddefine
*==========================================================================
*==========================================================================
*==========================================================================